package org.obm.sync.client.setting;

import java.util.Map;

import org.obm.sync.auth.AccessToken;
import org.obm.sync.auth.AuthFault;
import org.obm.sync.auth.ServerFault;
import org.obm.sync.client.impl.AbstractClientImpl;
import org.obm.sync.services.ISetting;
import org.obm.sync.setting.SettingItemsParser;
import org.obm.sync.setting.SettingItemsWriter;
import org.w3c.dom.Document;

@SuppressWarnings("unused")
public class SettingClient extends AbstractClientImpl implements ISetting{

	private SettingItemsParser respParser;
	private SettingItemsWriter siw;
	
	public SettingClient(String backendUrl) {
		super(backendUrl);
		respParser = new SettingItemsParser();
		siw = new SettingItemsWriter();
	}

	@Override
	public Map<String, String> getSettings(AccessToken token)  throws AuthFault, ServerFault {
		Map<String, String> params = initParams(token);
		Document doc = execute("/setting/getSettings", params);
		checkServerError(doc);
		return respParser.parseListSettings(doc);
	}
}
