package org.obm.sync.services;

import java.util.Date;
import java.util.List;

import org.obm.sync.auth.AccessToken;
import org.obm.sync.auth.AuthFault;
import org.obm.sync.auth.ServerFault;
import org.obm.sync.base.KeyList;
import org.obm.sync.book.BookType;
import org.obm.sync.book.Contact;
import org.obm.sync.items.ContactChanges;


public interface IAddressBook {

	public boolean isReadOnly(AccessToken token, BookType book) throws AuthFault,
			ServerFault;

	public BookType[] listBooks(AccessToken token);

	public ContactChanges getSync(AccessToken token, BookType book, Date d)
			throws AuthFault, ServerFault;

	public Contact createContact(AccessToken token, BookType book, Contact contact)
			throws AuthFault, ServerFault;

	public Contact createContactWithoutDuplicate(AccessToken token,
			BookType book, Contact contact) throws AuthFault, ServerFault;

	public Contact modifyContact(AccessToken token, BookType book, Contact contact)
			throws AuthFault, ServerFault;

	public Contact removeContact(AccessToken token, BookType book, String uid)
			throws AuthFault, ServerFault;
	
	public List<Contact> searchContact(AccessToken token, String query, int limit) throws AuthFault, ServerFault;

	// Methods for Funambol sync

	public Contact getContactFromId(AccessToken token, BookType book, String id)
			throws AuthFault, ServerFault;

	public KeyList getContactTwinKeys(AccessToken token, BookType book,
			Contact contact) throws AuthFault, ServerFault;
}
