package org.obm.sync.setting;

import java.util.AbstractMap;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import org.obm.sync.items.AbstractItemsParser;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class SettingItemsParser extends AbstractItemsParser {

	public Map<String, String> parseListSettings(Document doc) {
		Map<String, String> settings = new HashMap<String, String>();
		Element root = doc.getDocumentElement();

		NodeList nlSetting = root.getElementsByTagName("setting");
		for (int i = 0; i < nlSetting.getLength(); i++) {
			Element set = (Element) nlSetting.item(i);
			Entry<String, String> e = parseSetting(set);
			settings.put(e.getKey(), e.getValue());
		}

		return settings;
	}
	
	public Entry<String, String> parseSetting(Element e) {
		return new AbstractMap.SimpleEntry<String, String>(s(e, "key"),s(e, "value")); 
		
	}
	
	
}
