#!/bin/bash

source /etc/qemu-kvm.conf

test -f ${HOME}/${vm_storage_dir}/$1/vm.conf || {
    echo "usage: $0 <vm_name> where vm_name is a valid virtual machine name"
    exit 1
}

ant main.dist && \
scp_vm.sh $1 dist/WEB-INF/lib/obm-sync.jar dist/WEB-INF/lib/commons-codec-1.3.jar dist/WEB-INF/lib/ical4j-1.0-rc1.jar dist/WEB-INF/lib/commons-lang-2.4.jar descriptors/web.xml 

connect_vm.sh $1 <<EOF
mv web.xml /usr/lib/obm-sync/WEB-INF
mv obm-sync.jar /usr/lib/obm-sync/WEB-INF/lib/obm-sync.jar
mv ical4j-1.0-rc1.jar /usr/lib/obm-sync/WEB-INF/lib/ical4j-1.0-rc1.jar
mv commons-lang-2.4.jar /usr/lib/obm-sync/WEB-INF/lib/commons-lang-2.4.jar
mv commons-codec-1.3.jar /usr/lib/obm-sync/WEB-INF/lib/commons-codec-1.3.jar
logout
EOF

# funis
ant client.dist && scp_vm.sh $1 dist-client/obm-sync-client.jar
test -d ${HOME}/svn/obm-funambol/branches/2.2/lib && {
    cp dist-client/obm-sync-client.jar ${HOME}/svn/obm-funambol/branches/2.2/lib
}

connect_vm.sh $1 <<EOF
mkdir -p /usr/lib/funambol-6.5.1/funambol/WEB-INF/lib/
cp obm-sync-client.jar /usr/lib/funambol-6.5.1/funambol/WEB-INF/lib/
touch /usr/lib/obm-sync/WEB-INF/obm-sync.xml
/etc/init.d/obm-tomcat restart
EOF


