/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
package fr.aliacom.obm.common;

import org.obm.sync.base.IStoppable;

/**
 * A time/object pair, used in timeout map implementation
 * 
 * @author tom
 * 
 */
public class TimedItem<V extends IStoppable> {
	private long time;
	private V value;

	/**
	 * Creates a timed item with the given time & value.
	 * 
	 * @param time
	 * @param value
	 */
	public TimedItem(long time, V value) {
		this.time = time;
		this.value = value;
	}

	/**
	 * @return
	 */
	public long getTime() {
		return time;
	}

	/**
	 * @return
	 */
	public V getValue() {
		return value;
	}

	/**
	 * @param l
	 */
	public void setTime(long l) {
		time = l;
	}

	/**
	 * @param object
	 */
	public void setValue(V object) {
		value = object;
	}

}
