package fr.aliacom.obm.common.setting;

import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.obm.sync.auth.AccessToken;
import org.obm.sync.auth.AuthFault;
import org.obm.sync.auth.ServerFault;
import org.obm.sync.services.ISetting;

import fr.aliacom.obm.common.UserManagement;
import fr.aliacom.obm.common.contact.AddressBookBindingImpl;

public class SettingBindingImpl implements ISetting {

	private static final Log logger = LogFactory
			.getLog(AddressBookBindingImpl.class);

	private UserManagement um;

	public SettingBindingImpl() {
		this.um = UserManagement.getInstance();
	}

	@Override
	public Map<String, String> getSettings(AccessToken token) throws ServerFault, AuthFault {
		um.checkToken(token);
		try {
			logger.info("[" + token.getUser() + "] Setting : getSettings()");
			return SettingService.getInstance().getSettings(token);
		} catch (Throwable e) {
			logger.error(e.getMessage(), e);
			throw new ServerFault(e.getMessage());
		}
	}
}
