/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
package fr.aliacom.obm.services.constant;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * Service pour lecture des constantes du 
 * <code>/etc/obm/obm_conf.ini</code>
 * 
 * @author mehdi
 *
 */
public class ConstantService {	
	
	private static final Log logger = LogFactory.getLog(ConstantService.class);
	
	
	private static ConstantService cs = new ConstantService();
	
	public static ConstantService getInstance() {
		return cs;
	}
	
	private Properties props;
	
	private ConstantService() {
		props = new Properties();
		FileInputStream in = null;
		try {
			in = new FileInputStream("/etc/obm/obm_conf.ini");
			props.load(in);
		} catch (IOException e) {
			logger.error("No constants.properties found in classpath", e);
		} finally {
			if (in != null) {
				try {
					in.close();
				} catch (IOException e) {
				}
			}
		}
	}
	
	public String getStringValue(String prop) {
		return props.getProperty(prop);
	}
	
	public boolean getBooleanValue(String prop) {
		return Boolean.valueOf(getStringValue(prop)).booleanValue();
	}
	
	public int getIntValue(String prop) {
		return Integer.parseInt(getStringValue(prop));
	}

}
