/* ***** BEGIN LICENSE BLOCK *****
 * 
 * Copyright (c) 1997-2008 Aliasource - Groupe LINAGORA
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 * 
 *  http://www.obm.org/                                              
 * 
 * ***** END LICENSE BLOCK ***** */
package org.obm.sync.server.auth;

import java.io.File;

import org.obm.sync.server.auth.impl.DatabaseAuthentificationService;

import fr.aliacom.obm.ldap.LDAPAuthService;
import fr.aliacom.obm.services.constant.ConstantService;

/**
 * Fetches the ldap or database authentification service. The switch is
 * automatically done by checking if the file
 * <code>/etc/obm/ldap-auth.xml</code> exists.
 * 
 * @author tom
 * 
 */
public class AuthentificationServiceFactory {

	private boolean isLDAPBasedLogin() {
		return new File(LDAPAuthService.LDAP_CONF).exists()
				|| ConstantService.getInstance().getStringValue(
						"auth-ldap-server") != null;
	}

	public IAuthentificationService get() {
		if (isLDAPBasedLogin()) {
			return LDAPAuthService.get();
		} else {
			return new DatabaseAuthentificationService();
		}
	}

}
