package org.obm.sync.client.setting;

import java.util.Map;

import org.obm.sync.ObmSyncTestCase;
import org.obm.sync.auth.AccessToken;
import org.obm.sync.book.Contact;
import org.obm.sync.calendar.Event;
import org.obm.sync.locators.SettingLocator;

public class SettingClientTests extends ObmSyncTestCase {

	protected SettingClient settingClient;
	protected AccessToken token;

	public void testGetSettings() {
		try {
			Map<String, String> ret = settingClient.getSettings(token);
			assertNotNull(ret);
			assertTrue(ret.size() > 0);

		} catch (Exception e) {
			e.printStackTrace();
			fail("error on getSetting");
		}
	}

	public void testGetSettingsLoop() {
		int COUNT = 1000;
		long time = System.currentTimeMillis();
		try {
			for (int i = 0; i < COUNT; i++) {
				settingClient.getSettings(token);
			}
		} catch (Exception e) {
			e.printStackTrace();
			fail("error on getSetting");
		}
		time = System.currentTimeMillis() - time;
		System.err.println(COUNT + " getSettings done in " + time + "ms.");
	}

	@Override
	protected void setUp() throws Exception {
		super.setUp();
		settingClient = SettingLocator.locate(p("obm.sync.url"));
		assertNotNull(settingClient);
		token = settingClient.login(p("login"), p("password"), "junit");
		assertNotNull(token);
	}

	@Override
	protected void tearDown() throws Exception {
		settingClient.logout(token);
		super.tearDown();
	}

	@Override
	protected Contact getTestContact() {
		return null;
	}

	@Override
	protected Event getTestEvent() {
		return null;
	}

}
