package fr.aliasource.obm.conf;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;

public class ObmConfig {

	public static final String CONF = "/etc/obm/obm_conf.ini";

	private Map<String, String> props;
	private InputStream obmConf;

	public ObmConfig(InputStream in) {
		this.obmConf = in;
		props = new HashMap<String, String>();
	}

	public ObmConfig() throws IOException {
		this(new FileInputStream(CONF));
	}

	public void parse() throws IOException {
		BufferedReader raf = new BufferedReader(new InputStreamReader(obmConf));

		String line;
		while ((line = raf.readLine()) != null) {
			if (line.trim().length() == 0 || line.charAt(0) == ';'
					|| line.charAt(0) == '[') {
				continue;
			}
			String[] var = line.split("=");
			if (var.length == 2) {
				String key = var[0].trim();
				String val = var[1].trim();
				if (key.equals("password")) {
					val = val.substring(1, val.length() - 1);
				}
				props.put(key, val);
			}
		}
	}

	public String getProperty(String key) {
		return props.get(key);
	}

}
