package fr.aliasource.obm.tomcat;

import java.util.LinkedList;
import java.util.List;

/**
 * A Tomcat context
 * 
 * @author tom
 *
 */
public class Context {
	
	private List<DbConnection> connections;
	private String contextPath;
	private String docBase;
	
	public Context(String contextPath, String docBase) {
		this.contextPath = contextPath;
		this.docBase = docBase;
		this.connections = new LinkedList<DbConnection>();
	}

	public void addDbConnection(DbConnection con) {
		connections.add(con);
	}
	
	public List<DbConnection> getConnections() {
		return connections;
	}

	public String getContextPath() {
		return contextPath;
	}

	public String getDocBase() {
		return docBase;
	}
	
}
