package fr.aliasource.obm.tomcat;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;


/**
 * Reads the properties :
 * obm.sync.root
 * obm.sync.ds.jndiname
 * obm.funambol.root
 * obm.funambol.ds.jndiname
 * 
 * @author tom
 *
 */
public class WriterParams {

	private Properties props;

	public static final String CONTEXT_ROOT = "context.root";
	public static final String CONTEXT_PATH = "context.path";
	public static final String CONTEXT_CONF_PATH = "context.conf.path";
	public static final String CONTEXT_DS_JNDINAME = "context.ds.jndiname";
	public static final String CONTEXT_ALIAPOOL_BASED = "context.aliapool";

	WriterParams(InputStream in) throws IOException {
		this.props = new Properties();
		props.load(in);
	}
	
	String getProperty(String name) {
		return props.getProperty(name);
	}
	
}
